Index: trunk/src/org/expeditee/gio/swing/SwingInputManager.java
===================================================================
--- trunk/src/org/expeditee/gio/swing/SwingInputManager.java	(revision 1414)
+++ trunk/src/org/expeditee/gio/swing/SwingInputManager.java	(revision 1415)
@@ -4,4 +4,6 @@
 import java.awt.Color;
 import java.awt.Dimension;
+import java.awt.KeyEventDispatcher;
+import java.awt.KeyboardFocusManager;
 import java.awt.MouseInfo;
 import java.awt.Robot;
@@ -33,4 +35,6 @@
 import org.expeditee.gio.input.InputEvent.InputType;
 import org.expeditee.gio.input.KBMInputEvent;
+import org.expeditee.gio.input.KBMInputEvent.Key;
+import org.expeditee.gio.input.StandardInputEventListeners;
 import org.expeditee.gui.Popup;
 import org.expeditee.gui.PopupManager;
@@ -38,5 +42,5 @@
 
 public class SwingInputManager extends InputManager implements ComponentListener, WindowListener, WindowStateListener,
-		KeyListener, MouseListener, MouseMotionListener, MouseWheelListener {
+		KeyListener, MouseListener, MouseMotionListener, MouseWheelListener, KeyEventDispatcher {
 	/** Singleton instance. */
 	private static SwingInputManager _instance;
@@ -73,5 +77,5 @@
 		// Sign up to receive input as events
 		SwingGraphicsManager graphicsManager = SwingMiscManager.getIfUsingSwingGraphicsManager();
-		if (graphicsManager != null) {
+		if (graphicsManager != null) {			
 			graphicsManager.addWindowListener(swingInputManager);
 			graphicsManager.addWindowStateListener(swingInputManager);
@@ -91,6 +95,6 @@
 			graphicsManager.getGlassPane().setVisible(true);
 			graphicsManager.getContentPane().setBackground(Color.WHITE);
-			graphicsManager.getContentPane().setFocusTraversalKeysEnabled(false);
-		}
+		}
+		graphicsManager.getContentPane().setFocusTraversalKeysEnabled(false);
 
 		// Set up the robot (for controlling the mouse)
@@ -111,4 +115,16 @@
 		});
 		_timer.setRepeats(false);
+		
+//		AWTEventListener[] listeners = Toolkit.getDefaultToolkit().getAWTEventListeners();
+//		for (AWTEventListener listener: listeners) {
+//			System.err.println(listener);
+//			F10FriendlyKeyboardFocusManager keyboardManager = new F10FriendlyKeyboardFocusManager(listener);
+//			KeyboardFocusManager.setCurrentKeyboardFocusManager(keyboardManager);
+//		}
+//		
+//		F10FriendlyKeyboardFocusManager keyboardManager = new F10FriendlyKeyboardFocusManager(this);
+//		KeyboardFocusManager.setCurrentKeyboardFocusManager(keyboardManager);
+
+		KeyboardFocusManager.getCurrentKeyboardFocusManager().addKeyEventDispatcher(this);
 	}
 
@@ -222,4 +238,5 @@
 	@Override
 	public void mouseWheelMoved(MouseWheelEvent e) {
+		//ensureShiftAltStateCorrect(e);
 		// Give widgets first whack at input
 		distributeNativeInput(e);
@@ -247,4 +264,6 @@
 	@Override
 	public void mouseMoved(MouseEvent e) {
+		//ensureShiftAltStateCorrect(e);
+		
 		// Update the cursor position
 		updateCursorPosition(e.getX(), e.getY());
@@ -271,4 +290,5 @@
 	@Override
 	public void mouseClicked(MouseEvent e) {
+		//ensureShiftAltStateCorrect(e);
 		// Give widgets first whack at input
 		distributeNativeInput(e);
@@ -282,4 +302,5 @@
 	@Override
 	public void mousePressed(MouseEvent e) {
+		//ensureShiftAltStateCorrect(e);
 		mouseAction(e, true);
 	}
@@ -287,4 +308,5 @@
 	@Override
 	public void mouseReleased(MouseEvent e) {
+		//ensureShiftAltStateCorrect(e);
 		mouseAction(e, false);
 	}
@@ -324,4 +346,5 @@
 		} catch (Exception exception) {
 			System.err.println("SwingInputManager::mouseAction: " + exception.getMessage());
+			exception.printStackTrace();
 		}
 	}
@@ -349,12 +372,13 @@
 	@Override
 	public void keyTyped(KeyEvent e) {
-		//System.err.println("SwingInputManager::keyTyped::KeyEvent: " + e.getKeyChar());
+		//System.err.println("SwingInputManager::keyTyped::" + KeyEvent.getKeyText(e.getKeyCode()));
+		//ensureShiftAltStateCorrect(e);
+		
 		// Give widgets first whack at input
 		distributeNativeInput(e);
 		if (e.isConsumed()) {
-			//System.err.println("SwingInputManager::keyTyped::Widget/Popup Consumed KeyEvent");
-			return;
-		}
-
+			return;
+		}
+		
 		try {
 			// Ignore escape character and control characters
@@ -376,4 +400,6 @@
 	@Override
 	public void keyPressed(KeyEvent e) {
+		//System.err.println("SwingInputManager::keyPressed::" + KeyEvent.getKeyText(e.getKeyCode()));
+		//ensureShiftAltStateCorrect(e);
 		keyAction(e, true);
 	}
@@ -381,23 +407,64 @@
 	@Override
 	public void keyReleased(KeyEvent e) {
+		//System.err.println("SwingInputManager::keyReleased::" + KeyEvent.getKeyText(e.getKeyCode()));
 		keyAction(e, false);
 	}
+
+//	private void ensureShiftAltStateCorrect(java.awt.event.InputEvent inputEvent) {
+////		Component source = (Component) e.getSource();
+////		int id = KeyEvent.KEY_RELEASED;
+////		long when = System.currentTimeMillis();
+////		int keyCode = KeyEvent.VK_UNDEFINED;
+////		char keyChar = KeyEvent.CHAR_UNDEFINED;
+//		
+////		int modifiers = (e.getModifiers() & ~KeyEvent.SHIFT_DOWN_MASK);
+////		KeyEvent event = new KeyEvent(source, id, when, modifiers, keyCode, keyChar);
+////		Toolkit.getDefaultToolkit().getSystemEventQueue().postEvent(event);
+//		
+//		boolean shiftIsDownInRecordedState = StandardInputEventListeners.kbmStateListener.isKeyDown(Key.SHIFT);
+//		boolean shiftIsDownEventState = inputEvent.isShiftDown();
+//		if (shiftIsDownInRecordedState && !shiftIsDownEventState) {
+//			try {
+//				// Create an input event
+//				InputEvent event = new KBMInputEvent(KBMInputEvent.EventType.KEY_UP, KBMInputEvent.Key.SHIFT);
+//				System.err.println("SwingInputManager::ensureShiftAltStateCorrect::Sending followup Shift Up");
+//				
+//				// Translate and perform the input
+//				distributeInputEvent(event);
+//			} catch (Exception exception) {
+//				System.err.println(exception.getMessage());
+//			}
+//		}
+		
+//		System.err.println("SwingInputManager::ensureShiftAltStateCorrect::datastructure shift down: " + shiftIsDownInRecordedState);
+//		if (shiftIsDownInRecordedState != e.isShiftDown() && !e.isShiftDown()) {
+//			System.err.println("SwingInputManager::ensureShiftAltStateCorrect::Sending shift up event.");
+//			int modifiers = (e.getModifiers() & ~KeyEvent.SHIFT_DOWN_MASK);
+//			KeyEvent event = new KeyEvent(source, id, when, modifiers, keyCode, keyChar);
+//			Toolkit.getDefaultToolkit().getSystemEventQueue().postEvent(event);
+//		}		
+		
+//		boolean altIsDown = StandardInputEventListeners.kbmStateListener.isKeyDown(Key.ALT);
+//		if (altIsDown != e.isAltDown() && !e.isAltDown()) {
+//			System.err.println("SwingInputManager::ensureShiftAltStateCorrect::Sending alt up event.");
+//			int modifiers = (e.getModifiers() & ~KeyEvent.ALT_DOWN_MASK);
+//			KeyEvent event = new KeyEvent(source, id, when, modifiers, keyCode, keyChar);
+//			Toolkit.getDefaultToolkit().getSystemEventQueue().postEvent(event);
+//		}
+//	}
 
 	/** Handles key pressed/released events. */
 	private void keyAction(KeyEvent e, boolean down) {
-		//System.err.println("SwingInputManager::keyAction::KeyEvent: " + e.getKeyChar());
 		// Give widgets first whack at input
 		distributeNativeInput(e);
 		if (e.isConsumed()) {
-			//System.err.println("SwingInputManager::keyAction::Was consumed: " + e.isConsumed());
-			return;
-		}
-		//System.err.println("SwingInputManager::keyAction::Was consumed: " + e.isConsumed());
-
+			return;
+		}
+		
 		KBMInputEvent.Key key = SwingConversions.fromSwingVirtualKey(e.getKeyCode());
 		if (key == null) {
 			return;
 		}
-
+		
 		try {
 			// Create an input event
@@ -424,14 +491,13 @@
 	/** Forwards the given input event to the listener if it is listening for it. */
 	private void forwardNativeInputToListener(Object listener, java.awt.event.InputEvent event) {
-		//System.err.println("SwingInputManager::forwardNativeInputToListener");
 		if (listener == null || event == null) {
 			return;
 		}
-		//System.err.println("SwingInputManager::forwardNativeInputToListener::Recieving input: " + event.toString());
+		
 		if (listener instanceof KeyListener && event instanceof KeyEvent) {
 
 			KeyListener keyListener = (KeyListener) listener;
 			KeyEvent ke = (KeyEvent) event;
-
+			
 			switch (event.getID()) {
 			case KeyEvent.KEY_PRESSED:
@@ -442,5 +508,4 @@
 				return;
 			case KeyEvent.KEY_TYPED:
-				//System.err.println("SwingInputManager::forwardNativeInputToListener::Recieving key typed: " + event.toString());
 				keyListener.keyTyped(ke);
 				return;
@@ -632,3 +697,21 @@
 
 	}
+
+	@Override
+	public boolean dispatchKeyEvent(KeyEvent e) {
+		if (e.getKeyCode() == KeyEvent.VK_F10) {
+			if (KeyEvent.KEY_PRESSED == e.getID()) {
+				keyPressed(e);
+			} else if (KeyEvent.KEY_RELEASED == e.getID()) {
+				keyReleased(e);
+			} else if (KeyEvent.KEY_TYPED == e.getID()) {
+				keyTyped(e);
+			} else {
+				System.err.println("SwingInputManager::dispatchKeyEvent::Found Key that is not pressed, "
+						+ "released or typed.  What is it?  " + e.getID());
+			}
+			return true;
+		}
+		return false;
+	}
 }
Index: trunk/src/org/expeditee/gio/swing/SwingTextLayoutManager.java
===================================================================
--- trunk/src/org/expeditee/gio/swing/SwingTextLayoutManager.java	(revision 1414)
+++ trunk/src/org/expeditee/gio/swing/SwingTextLayoutManager.java	(revision 1415)
@@ -262,5 +262,11 @@
 			}
 			
-			java.awt.font.TextLayout layout = lineBreaker.nextLayout(width, end, dontBreakWords);
+			java.awt.font.TextLayout layout = null;
+
+			try {
+				layout = lineBreaker.nextLayout(width, end, dontBreakWords);
+			} catch (ArrayIndexOutOfBoundsException e) {
+				e.printStackTrace();
+			}
 			
 			// If it's impossible to layout any more text without breaking a word, just do it
Index: trunk/src/org/expeditee/gui/AttributeUtils.java
===================================================================
--- trunk/src/org/expeditee/gui/AttributeUtils.java	(revision 1414)
+++ trunk/src/org/expeditee/gui/AttributeUtils.java	(revision 1415)
@@ -19,4 +19,5 @@
 package org.expeditee.gui;
 
+import java.lang.reflect.Field;
 import java.lang.reflect.InvocationTargetException;
 import java.lang.reflect.Method;
@@ -331,4 +332,6 @@
 			_Attrib.put("TabIndex", 			Text.class.getMethod("getTabIndex"), 
 												Text.class.getMethod("setTabIndex", pInt));
+			_Attrib.put("EnterClick", 			Item.class.getMethod("acceptsKeyboardEnter"), 
+												Item.class.getMethod("setAcceptsEnter", pBool));
 			
 			// Aliases for attribute setting
@@ -566,8 +569,23 @@
 			sb.deleteCharAt(sb.length() - 1);
 			o = sb.toString();
-		} else if (o instanceof Boolean) {
-			// true is the default for boolean values
-			if (((Boolean) o).booleanValue()) {
-				return null;
+		} else if (o instanceof Boolean) {	
+			try {
+				Class<?> parentClass = item.getClass();
+				Field defaultValueField = parentClass.getField(a.getter.getName() + "Default");
+				boolean defaultValue = defaultValueField.getBoolean(null);
+				if (defaultValue == (boolean) o) {
+					return null;
+				}
+			} catch (IllegalArgumentException e) {
+				e.printStackTrace();
+			} catch (SecurityException e) {
+				e.printStackTrace();
+			} catch (NoSuchFieldException e) {
+				// true is the default for boolean values when no other default is provided
+				if ((boolean) o) {
+					return null;
+				}
+			} catch (IllegalAccessException e) {
+				e.printStackTrace();
 			}
 		}
Index: trunk/src/org/expeditee/gui/Browser.java
===================================================================
--- trunk/src/org/expeditee/gui/Browser.java	(revision 1414)
+++ trunk/src/org/expeditee/gui/Browser.java	(revision 1415)
@@ -274,5 +274,7 @@
 		if (!AuthenticatorBrowser.isAuthenticationRequired() && UserSettings.PublicAndPrivateResources) {
 			String userName = UserSettings.ProfileName.get();
-			FrameIO.setupPersonalResources(userName);
+			if (!FrameIO.personalResourcesExist(userName)) {
+				FrameIO.setupPersonalResources(userName);
+			}
 		}
 		// Listen for save status to display during and after runtime
Index: trunk/src/org/expeditee/gui/DisplayController.java
===================================================================
--- trunk/src/org/expeditee/gui/DisplayController.java	(revision 1414)
+++ trunk/src/org/expeditee/gui/DisplayController.java	(revision 1415)
@@ -583,5 +583,5 @@
 			// frames differ.
 			if (getCurrentFrame() != null && !bothSidesHaveSameFrame()) {
-				for (Item i : getCurrentFrame().getItems()) {
+				for (Item i : getCurrentFrame().getSortedItems()) {
 					i.onParentStateChanged(new ItemParentStateChangedEvent(getCurrentFrame(), ItemParentStateChangedEvent.EVENT_TYPE_HIDDEN));
 				}
@@ -590,5 +590,5 @@
 
 			// BROOK : TODO... overlays and loadable widgets
-			for (Item i : getCurrentFrame().getItems()) {
+			for (Item i : getCurrentFrame().getSortedItems()) {
 				i.onParentStateChanged(new ItemParentStateChangedEvent(getCurrentFrame(), ItemParentStateChangedEvent.EVENT_TYPE_SHOWN));
 			}
@@ -671,5 +671,5 @@
 			}
 
-			for (Item i : frame.getItems()) {
+			for (Item i : frame.getSortedItems()) {
 				i.onParentStateChanged(new ItemParentStateChangedEvent(frame,
 						ItemParentStateChangedEvent.EVENT_TYPE_SHOWN));
@@ -925,5 +925,5 @@
 		StandardGestureActions.setHighlightHold(true);
 
-		for (Item i : frame.getItems()) {
+		for (Item i : frame.getSortedItems()) {
 			if (i.getLink() != null && i.getAbsoluteLink().toLowerCase().equals(oldFrame)) {
 				if (i.getHighlightMode() != Item.HighlightMode.Normal) {
@@ -1131,10 +1131,10 @@
 		} else {
 			ToggleAudienceMode();
-			ItemUtils.UpdateConnectedToAnnotations(current.getItems());
+			ItemUtils.UpdateConnectedToAnnotations(current.getSortedItems());
 			for (Overlay o : current.getOverlays()) {
-				ItemUtils.UpdateConnectedToAnnotations(o.Frame.getItems());
+				ItemUtils.UpdateConnectedToAnnotations(o.Frame.getSortedItems());
 			}
 			for (Vector v : current.getVectorsDeep()) {
-				ItemUtils.UpdateConnectedToAnnotations(v.Frame.getItems());
+				ItemUtils.UpdateConnectedToAnnotations(v.Frame.getSortedItems());
 			}
 		}
@@ -1207,6 +1207,5 @@
 	 * This results in the Frame being re-parsed and repainted.
 	 */
-	public static void ToggleXRayMode()
-	{
+	public static void ToggleXRayMode()	{
 		// Turn off x-ray mode if it is on
 		if (_audienceMode) {
Index: trunk/src/org/expeditee/gui/Frame.java
===================================================================
--- trunk/src/org/expeditee/gui/Frame.java	(revision 1414)
+++ trunk/src/org/expeditee/gui/Frame.java	(revision 1415)
@@ -77,5 +77,5 @@
  * 
  */
-public class Frame /*implements Cloneable*/ {
+public class Frame {
 	
 	/** The frame number to indicate this is a virtual frame. */
@@ -126,6 +126,4 @@
 
 	private boolean _isLocal = true;
-
-	private boolean _sorted = true;
 	
 	/** Whether the frame has changed and therefore needs saving. */
@@ -139,7 +137,13 @@
 	private Stack<History> _redo = new Stack<History>();
 
-	private List<Item> _body = new ArrayList<Item>();
-	private List<Item> _bodyHiddenDueToPermissions = new ArrayList<Item>();
-	private List<Item> _surrogates = new ArrayList<Item>();
+	private ItemsList _body = new ItemsList();
+	private ItemsList _bodyHiddenDueToPermissions = new ItemsList();
+	private ItemsList _primaryItemsBody = new ItemsList();
+	private ItemsList _surrogateItemsBody = new ItemsList();
+	
+	//private List<Item> _body = new ArrayList<Item>();
+	//private List<Item> _bodyHiddenDueToPermissions = new ArrayList<Item>();
+	//private List<Item> _primaryItemsBody = new ArrayList<Item>();
+	//private List<Item> _surrogateItemsBody = new ArrayList<Item>();
 
 	// for drawing purposes
@@ -184,75 +188,18 @@
 	private String _groupFrameName;
 	private Frame _groupFrame = null;
+	
+	public enum BodyType {
+		BodyDisplay, PrimaryBody, SurrogateBody;
+	}
 
 	/** Default constructor, nothing is set. */
 	public Frame() {
 	}
-	
-//	public Frame clone() {
-//		Frame clone = new Frame();
-//		for (Item i: this._body) { 
-//			Item copy = i.copy();
-//			copy.setID(i.getID());	
-//			clone._body.add(copy);
-//		}
-//		for(Item i: this._bodyHiddenDueToPermissions) { 
-//			Item copy = i.copy();
-//			copy.setID(i.getID());
-//			clone._bodyHiddenDueToPermissions.add(i);
-//		}
-//		if (this._frameName != null) {
-//			clone._frameName = this._frameName.copy();
-//		}
-//		for(Overlay key: this._overlays.keySet()) {
-//			clone._overlays.put(key, this._overlays.get(key));
-//		}
-//		for(Vector v: this._vectors) {
-//			clone._vectors.add(v);
-//		}
-//		for (Item i: this._interactableItems) {
-//			clone._interactableItems.add(i.copy());
-//		}
-//		for (Item i: this._overlayItems) {
-//			clone._overlayItems.add(i.copy());
-//		}
-//		for (Item i: this._vectorItems) {
-//			clone._vectorItems.add(i.copy());
-//		}
-//		clone._frameData = this._frameData;
-//		clone._frameset = this._frameset;
-//		clone._number = this._number;
-//		clone._version = this._version;
-//		clone._permissionTriple = this._permissionTriple;
-//		clone._owner = this._owner;
-//		clone._creationDate = this._creationDate;
-//		clone._modifiedUser = this._modifiedUser;
-//		clone._modifiedDate = this._modifiedDate;
-//		clone._modifiedDatePrecise = this._modifiedDatePrecise;
-//		clone._frozenDate = this._frozenDate;
-//		clone._background = this._background;
-//		clone._foreground = this._foreground;
-//		clone.path = this.path;
-//		clone._isLocal = this._isLocal;
-//		clone._sorted = this._sorted;
-//		clone._change = this._change;
-//		clone._saved = this._saved;
-//		clone._lineCount = this._lineCount;
-//		clone._itemCount = this._itemCount;
-//		clone._buffer = this._buffer;
-//		clone._validBuffer = this._validBuffer;
-//		clone._activeTime = (Time) this._activeTime.clone();
-//		clone._darkTime = (Time) this._darkTime.clone();
-//		clone._dotTemplate = this._dotTemplate.copy();
-//		
-//		return clone;
-//	}
-
-	public boolean isReadOnly()
-	{
+
+	public boolean isReadOnly() {
 		return !_frameName.hasPermission(UserAppliedPermission.full) && !_protectionChanged;
 	}
 
-	public void reset()
-	{
+	public void reset()	{
 		refreshItemPermissions(UserAppliedPermission.full);
 		resetDot();
@@ -403,26 +350,19 @@
 	 * @return The list of Item objects that are on this Frame.
 	 */
-	public List<Item> getItems(boolean visible)
-	{
-		if (!_sorted) {
-			for(int i = 0; i < _body.size();) {
-				if(_body.get(i) == null) {
-					_body.remove(i);
-				} else {
-					i++;
-				}
-			}
-			Collections.sort(_body);
-			_sorted = true;
-		}
-
+	public List<Item> getSortedItems(boolean requireVisible) {
+		ItemsList listToLoopOver = _body;
+		listToLoopOver.sort();
+		return getItems(requireVisible, listToLoopOver);
+	}
+	
+	public List<Item> getItems(boolean requireVisible, ItemsList listToLoopOver) {
 		List<Item> items = new ArrayList<Item>();
 
-		for (Item i : _body) {
+		for (Item i: listToLoopOver) {
 			if (i == null) {
 				continue;
 			}
 			
-			if (i.isVisible() || (!visible && !i.isDeleted())) {
+			if (meetsVisibilityRequirements(requireVisible, i)) {
 				items.add(i);
 			}
@@ -431,9 +371,9 @@
 		return items;
 	}
-
+	
 	/** TODO: Comment. cts16 */
-	public List<Item> getItems()
-	{
-		return getItems(false);
+	public List<Item> getSortedItems()
+	{
+		return getSortedItems(false);
 	}
 
@@ -443,10 +383,8 @@
 	 * @return True if this frame contains i.
 	 */
-	public boolean containsItem(Item i)
-	{
+	public boolean containsItem(Item i) {
 		if (i == null) {
 			throw new NullPointerException("i");
-		}
-		
+		}	
 		return _body.contains(i);
 	}
@@ -468,5 +406,5 @@
 		List<Text> bodyTextItems = new ArrayList<Text>();
 		
-		for (Item i : getItems(true)) {
+		for (Item i : getSortedItems(true)) {
 			// only add up normal body text items
 			if ((i instanceof Text) && ((includeAnnotations && !((Text) i).isSpecialAnnotation()) || !i.isAnnotation()) && !i.isLineEnd()) {
@@ -483,5 +421,5 @@
 	{
 		Collection<Item> items = new ArrayList<Item>();
-		for (Item i : getItems(true)) {
+		for (Item i : getSortedItems(true)) {
 			// only add up normal body text items
 			if (!i.isAnnotation()) {
@@ -505,5 +443,5 @@
 	public Item getLastNonAnnotationTextItem()
 	{
-		List<Item> items = getItems();
+		List<Item> items = getSortedItems();
 
 		// find the last non-annotation text item
@@ -910,11 +848,10 @@
 	 *            The date to set as the last frozen date.
 	 */
-	public void setFrozenDate(String date)	{
+	public void setFrozenDate(String date) {
 		_frozenDate = date;
 	}
 
-	public void setResort(boolean value)
-	{
-		_sorted = !value;
+	public void invalidateSorted() {
+		_body.invalidateSorted();
 	}
 
@@ -925,12 +862,21 @@
 	 *            The Item to add to this Frame.
 	 */
-	public void addItem(Item item)
-	{
+	public void addItem(Item item) {
 		addItem(item, true);
 	}
 
-	public void addItem(Item item, boolean recalculate)
-	{
-		if (item == null || item.equals(_frameName) || _body.contains(item)) {
+	public void addItem(Item item, boolean recalculate)	{
+		if (item == null) { return; }
+		
+		addItem(item, recalculate, _body);
+		if (item.isSurrogate()) {
+			addItem(item, recalculate, _surrogateItemsBody);
+		} else {
+			addItem(item, recalculate, _primaryItemsBody);
+		}
+	}
+	
+	protected void addItem(Item item, boolean recalculate, ItemsList list) {
+		if (item == null || item.equals(_frameName) || list.contains(item)) {
 			return;
 		}
@@ -948,5 +894,5 @@
 		_itemCount = Math.max(_itemCount, item.getID());
 
-		_body.add(item);
+		list.add(item);
 		item.setParent(this);
 		item.setFloating(false); // esnure that it is anchored
@@ -959,6 +905,6 @@
 			item.setPosition(item.getPosition());
 		}
-
-		_sorted = false;
+		
+		list.invalidateSorted();
 
 		// item.setMaxWidth(FrameGraphics.getMaxFrameSize().width);
@@ -983,6 +929,6 @@
 	}
 	
-	public void addToSurrogates(Item surrogate) {
-		this._surrogates.add(surrogate);
+	public void addToSurrogatesOnLoad(Item surrogate, Item parent) {
+		parent.addToSurrogates(surrogate);
 	}
 
@@ -991,5 +937,5 @@
 		boolean bReparse = false;
 		
-		for (Item i : getItems()) {
+		for (Item i : getSortedItems()) {
 			Integer anchorLeft   = i.getAnchorLeft();
 			Integer anchorRight  = i.getAnchorRight();
@@ -1039,6 +985,10 @@
 	}
 
-	public void addAllItems(Collection<Item> toAdd)
-	{
+	public void addAllItems(Collection<Item> toAdd)	{
+		addAllItems(toAdd, _body);
+		addAllItems(toAdd, _primaryItemsBody);
+	}
+	
+	protected void addAllItems(Collection<Item> toAdd, ItemsList list) {
 		for (Item i : toAdd) {
 			// If an annotation is being deleted clear the annotation list
@@ -1047,10 +997,9 @@
 			}
 			// TODO Improve efficiency when addAll is called
-			addItem(i);
-		}
-	}
-
-	public void removeAllItems(Collection<Item> toRemove)
-	{
+			addItem(i, true, list);
+		}
+	}
+
+	public void removeAllItems(Collection<Item> toRemove) {
 		for (Item i : toRemove) {
 			// If an annotation is being deleted clear the annotation list
@@ -1066,6 +1015,14 @@
 	}
 
-	public void removeItem(Item item, boolean recalculate)
-	{
+	public void removeItem(Item item, boolean recalculate) {
+		removeItem(item, recalculate, _body);
+		if (item.isSurrogate()) {
+			removeItem(item, recalculate, _surrogateItemsBody);
+		} else {
+			removeItem(item, recalculate, _primaryItemsBody);
+		}
+	}
+	
+	protected void removeItem(Item item, boolean recalculate, ItemsList toRemoveFrom) {
 		// If an annotation is being deleted clear the annotation list
 		if (item.isAnnotation()) {
@@ -1073,5 +1030,5 @@
 		}
 
-		if (_body.remove(item)) {
+		if (toRemoveFrom.remove(item)) {
 			change();
 			// Remove widgets from the widget list
@@ -1098,6 +1055,5 @@
 	 * @param type  The type of event that occurred
 	 */
-	private void addToUndo(Collection<Item> items, History.Type type)
-	{
+	private void addToUndo(ItemsList items, History.Type type) {
 		if (items.size() < 1) {
 			return;
@@ -1107,11 +1063,9 @@
 	}
 	
-	public void addToUndoDelete(Collection<Item> items)
-	{
+	public void addToUndoDelete(ItemsList items) {
 		addToUndo(items, History.Type.deletion);
 	}
 	
-	public void addToUndoMove(Collection<Item> items)
-	{
+	public void addToUndoMove(ItemsList items) {
 		addToUndo(items, History.Type.movement);
 	}
@@ -1147,6 +1101,6 @@
     		break;
 		case movement:
-			List<Item> changed = new LinkedList<Item>(_body);
-			changed.retainAll(undo.items);
+			ItemsList changed = new ItemsList(_body);
+			changed.retainHistory(undo.items);
 			_redo.push(new History(changed, History.Type.movement));
 			for(Item i : undo.items) {
@@ -1207,6 +1161,6 @@
     		break;
 		case movement:
-			List<Item> changed = new LinkedList<Item>(_body);
-			changed.retainAll(redo.items);
+			ItemsList changed = new ItemsList(_body);
+			changed.retainHistory(redo.items);
 			_undo.push(new History(changed, History.Type.movement));
 			for(Item i : redo.items) {
@@ -1677,5 +1631,5 @@
 	{
 		for (Overlay o : _overlays.keySet()) {
-			for (Item i : o.Frame.getItems()) {
+			for (Item i : o.Frame.getSortedItems()) {
 				i.onParentStateChanged(new ItemParentStateChangedEvent(
 								this,
@@ -1695,5 +1649,5 @@
 				_overlays.remove(o);
 				
-				for (Item i : f.getItems()) {
+				for (Item i : f.getSortedItems()) {
 					_overlayItems.remove(i);
 					i.onParentStateChanged(new ItemParentStateChangedEvent(
@@ -1788,5 +1742,5 @@
 		}
 
-		List<Item> copies = ItemUtils.CopyItems(toMergeWith.getItems());
+		List<Item> copies = ItemUtils.CopyItems(toMergeWith.getSortedItems());
 		copies.remove(toMergeWith.getNameItem());
 
@@ -1834,5 +1788,5 @@
 	public void clear(boolean keepAnnotations)
 	{
-		List<Item> newBody = new ArrayList<Item>(0);
+		ItemsList newBody = new ItemsList();
 		
 		Item title = getTitleItem();
@@ -2010,4 +1964,5 @@
 		// reset attributes
 		dot.setParent(this);
+		dot.setOwner(template.getOwner());
 		return dot;
 	}
@@ -2018,5 +1973,5 @@
 
 		// check for an updated template...
-		for (Item i : this.getItems()) {
+		for (Item i : this.getSortedItems()) {
 			if (ItemUtils.startsWithTag(i, templateTag)) {
 				t = (Text) i;
@@ -2032,5 +1987,5 @@
 			t = defaultTemplate;
 		}
-
+		
 		// If the item is linked apply any attribute pairs on the child frame
 		String link = t.getAbsoluteLink();
@@ -2038,4 +1993,8 @@
 		// need to get link first because copy doesnt copy the link
 		t = t.copy();
+		// If the template does not have a owner then it should be set to the current user.
+		if (t.getOwner() == null) {
+			t.setOwner(UserSettings.UserName.get());
+		}
 		t.setTooltip(null);
 		if (link != null) {
@@ -2202,5 +2161,5 @@
 	public boolean moveMouseToTextItem(int index)
 	{
-		List<Item> items = getItems();
+		List<Item> items = getSortedItems();
 		int itemsFound = 0;
 		for (int i = 0; i < items.size(); i++) {
@@ -2228,5 +2187,5 @@
 	public boolean moveMouseToDefaultLocation()
 	{
-		List<Item> items = getItems();
+		List<Item> items = getSortedItems();
 
 		for (Item it : items) {
@@ -2527,5 +2486,5 @@
 	public List<Item> getVisibleItems()
 	{
-		return getItems(true);
+		return getSortedItems(true);
 	}
 
@@ -2559,5 +2518,5 @@
 	 * @return the list of items to be saved to a text file
 	 */
-	public List<Item> getItemsToSave() {
+	/*public List<Item> getItemsToSave() {
 		if (!_sorted) {
 			Collections.sort(_body);
@@ -2599,10 +2558,51 @@
 
 		return toSave;
-	}
-	
-	public List<Item> getSurrogateItemsToSave() {
-		List<Item> surrogates = new ArrayList<Item>();
-		_body.forEach(item -> surrogates.addAll(item.getSurrogates()));
-		return surrogates;
+	}*/
+	
+	public List<Item> getItemsToSave() {
+		return getItemsToSave(BodyType.PrimaryBody);
+	}
+	
+	public List<Item> getItemsToSave(BodyType type) {
+		assert(!type.equals(BodyType.BodyDisplay));
+		switch (type) {
+		case SurrogateBody:
+			return getItemsToSave(_surrogateItemsBody);
+		case BodyDisplay:
+			return getItemsToSave(_body);
+		case PrimaryBody:
+		default:
+			return getItemsToSave(_primaryItemsBody);
+		}
+	}
+	
+	private List<Item> getItemsToSave(ItemsList body) {
+		body.sort();
+		List<Widget> seenWidgets = new ArrayList<Widget>();
+		
+		List<Item> toSave = new ArrayList<Item>();
+		
+		body.removeIf(item -> item.dontSave());
+		for (Item item: body) {
+			if (item instanceof WidgetCorner) {
+				// Save the widget source.  
+				// Each widget has multiple WidgetCorner's..ignore them if we already have the source. 
+				Widget iw = ((WidgetCorner) item).getWidgetSource();
+				if (seenWidgets.contains(iw)) { continue; }
+				seenWidgets.add(iw);
+				toSave.add(iw.getSource());
+			} else if (item instanceof XRayable) {
+				// XRayable Items have their sources saved.
+				XRayable x = (XRayable) item;
+				toSave.addAll(x.getItemsToSave());
+			} else if (item.hasEnclosures()) {
+				// Deals with Circle objects only?
+				continue;
+			} else {
+				toSave.add(item);
+			}
+		}
+		
+		return toSave;
 	}
 
@@ -2623,11 +2623,10 @@
 	}
 
-	public Collection<Item> getAllItems()
-	{
-		Collection<Item> allItems = new LinkedHashSet<Item>(_body);
+	public Collection<Item> getAllItems() {
+		ItemsList allItems = new ItemsList(_body);
 		
 		allItems.addAll(_overlayItems);
 		allItems.addAll(_vectorItems);
-		return allItems;
+		return allItems.underlying();
 	}
 
@@ -2648,5 +2647,5 @@
 		Collection<Text> textItems = new ArrayList<Text>();
 		
-		for (Item i : getItems(true)) {
+		for (Item i : getSortedItems(true)) {
 			// only add up normal body text items
 			if ((i instanceof Text)) {
@@ -2669,5 +2668,5 @@
 	public void recalculate()
 	{
-		for (Item i : getItems()) {
+		for (Item i : getSortedItems()) {
 			if (i.hasFormula() && !i.isAnnotation()) {
 				i.calculate(i.getFormula());
@@ -2700,5 +2699,5 @@
 		Collection<Text> items = new LinkedHashSet<Text>();
 		
-		for (Item i : getItems(true)) {
+		for (Item i : getSortedItems(true)) {
 			// only add up normal body text items
 			if (i instanceof Text && !i.isAnnotation()) {
@@ -2788,6 +2787,6 @@
 	}
 	
-	public List<Item> getBodyItemsWithInsufficientPermissions() {
-		return _bodyHiddenDueToPermissions;
+	public Collection<Item> getBodyItemsWithInsufficientPermissions() {
+		return _bodyHiddenDueToPermissions.underlying();
 	}
 	
@@ -2898,4 +2897,12 @@
 		return members;
 	}
+	
+	public boolean hasSurrogates() {
+		return !_surrogateItemsBody.isEmpty();
+	}
+
+	private boolean meetsVisibilityRequirements(boolean requireVisible, Item i) {
+		return i.isVisible() || (!requireVisible && !i.isDeleted());
+	}
 
 	private static final class History {
@@ -2906,11 +2913,11 @@
 		}
 		
-		public final List<Item> items;
+		public final ItemsList items;
 		
 		public final Type type;
 		
-		public History(Collection<Item> items, Type type)
+		public History(ItemsList changed, Type type)
 		{
-			this.items = new LinkedList<Item>(items);
+			this.items = new ItemsList(changed);
 			this.type = type;
 		}
@@ -2922,3 +2929,17 @@
 		}
 	}
+
+	protected boolean hasAnnotations() {
+		return _annotations != null && _annotations.size() > 0;
+	}
+
+	protected ItemsList getBody() {
+		return _body;
+	}
+	protected ItemsList getPrimaryBody() {
+		return _primaryItemsBody;
+	}
+	protected ItemsList getSurrogateBody() {
+		return _surrogateItemsBody;
+	}
 }
Index: trunk/src/org/expeditee/gui/FrameCreator.java
===================================================================
--- trunk/src/org/expeditee/gui/FrameCreator.java	(revision 1414)
+++ trunk/src/org/expeditee/gui/FrameCreator.java	(revision 1415)
@@ -276,5 +276,5 @@
 		_lastX = START_X;
 		// Check for @Start
-		for (Item it : toUse.getItems()) {
+		for (Item it : toUse.getSortedItems()) {
 			if (it instanceof Text) {
 				Text t = (Text) it;
